﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["GridData"] == null)
        {
            Session["GridData"] = GetEmployees(50);
            WebDataGrid1.DataSource = Session["GridData"];
            WebDataGrid1.DataBind();

            //DropDown.EditorControl.DataSource = GetDepartments();
            //DropDown.EditorControl.DataBind();
        }
        else
        {
            WebDataGrid1.DataSource = Session["GridData"];
            WebDataGrid1.DataBind();

            //DropDown.EditorControl.DataSource = GetDepartments();
        }
    }

    private DataTable GetDepartments()
    {
        DataTable dt = new DataTable("Departments");
        dt.Columns.Add("DepartmentID", typeof(int));
        dt.Columns.Add("DepartmentName", typeof(string));

        for (int i = 0; i < 8; i++)
        {
            dt.Rows.Add(new object[] { i, string.Format("Depart. {0}", i) });
        }

        dt.PrimaryKey = new DataColumn[] { dt.Columns["DepartmentID"] };

        return dt;
    }

    private DataTable GetEmployees(int count)
    {
        DataTable dtData = new DataTable("Employees");

        dtData.Columns.Add("EmployeeID", typeof(int));
        dtData.Columns.Add("Name", typeof(string));
        dtData.Columns.Add("OnSite", typeof(bool));
        dtData.Columns.Add("DateOfHire", typeof(DateTime));
        dtData.Columns.Add("Department", typeof(int));


        for (int i = 0; i < count; i++)
        {
            dtData.Rows.Add(new object[] { i, string.Format("Name {0}", i), (i % 2 == 0), DateTime.Today.Date.AddDays(-1 * i), i });
        }

        dtData.PrimaryKey = new DataColumn[] { dtData.Columns["EmployeeID"] };

        return dtData;
    }

    protected void WebDataGrid1_RowUpdating(object sender, Infragistics.Web.UI.GridControls.RowUpdatingEventArgs e)
    {
        DataTable dtData = (DataTable)Session["GridData"];

        dtData.Rows[e.Row.Index]["EmployeeID"] = e.Values["EmployeeID"];
        dtData.Rows[e.Row.Index]["Name"] = e.Values["Name"];
        dtData.Rows[e.Row.Index]["OnSite"] = e.Values["OnSite"];
        dtData.Rows[e.Row.Index]["DateOfHire"] = e.Values["DateOfHire"];
        dtData.Rows[e.Row.Index]["Department"] = e.Values["Department"];

        Session["GridData"] = dtData;
    }
    protected void WebDataGrid1_RowAdding(object sender, Infragistics.Web.UI.GridControls.RowAddingEventArgs e)
    {
        DataTable dtData = (DataTable)Session["GridData"];

        dtData.Rows.Add(new object[] { e.Values["EmployeeID"], e.Values["Name"], e.Values["OnSite"], e.Values["DateOfHire"], e.Values["Department"] });

        Session["GridData"] = dtData;
    }
    protected void WebDataGrid1_RowsDeleting(object sender, Infragistics.Web.UI.GridControls.RowDeletingEventArgs e)
    {
        DataTable dtData = (DataTable)Session["GridData"];

        dtData.Rows.RemoveAt(e.Row.Index);

        Session["GridData"] = dtData;
    }
    protected void Button1_Click(object sender, EventArgs e)
    {

    }
    protected void WebDataGrid1_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
    {
        e.Row.Items[0].Text = e.Row.Items[0].Value.ToString() + "%";
    }
}